#include "timestamp.h"


int64_t timestamp_now() {

    struct timespec tp;
    clock_gettime(CLOCK_REALTIME, &tp);

    return timestamp_from_timespec(&tp);

}

int64_t timestamp_from_timespec(const struct timespec *tp) {

    int64_t timestamp = (((int64_t)tp->tv_sec) * TIMESTAMP_ONE_SECOND) + (tp->tv_nsec / 1000);
    long leftover_ns = tp->tv_nsec % 1000;

    if (leftover_ns >= 500) {
        timestamp += 1;
    }

    return timestamp;

}

int64_t timestamp_from_double(double d) {

    int64_t sec = (int64_t)d;

    d -= sec;
    d *= TIMESTAMP_ONE_SECOND;

    int64_t frac = (int64_t)d;

    return (sec * TIMESTAMP_ONE_SECOND) + frac;

}

double timestamp_to_double(int64_t t) {

    int64_t sec  = t / TIMESTAMP_ONE_SECOND;
    int64_t frac = t % TIMESTAMP_ONE_SECOND;

    double dsec  = sec;
    double dfrac = frac;

    return dsec + (dfrac / TIMESTAMP_ONE_SECOND);

}
