@echo off

:: pnputil based (un)install

:: 1. Remove known/cached devices, where
::   Instance ID:               USB\VID_289B or USB\VID_1781
::
:: 2. Search and remove old libusb0 driver package, where:
::   Published name:            oemXYZ.inf
::   Original name:   		usbtenki.inf
::
:: 3. Add package %1
::
:: 4. Update system (scan devices)


setlocal EnableDelayedExpansion


if "%~1"=="" (
    echo "No driver package specified"
    echo "Usage: %0 <driver_package_dir_path>"
    exit /b 1
)


echo Installing %1

:: Delete old devices(s)

set devices_data="%WINDIR%\System32\pnputil.exe /enum-devices | findstr "USB\VID_289B USB\VID_1781""

for /F "eol=. tokens=*" %%a in ( '%devices_data%' ) do (

	set line=%%a

	set instance_id=
	set instance_id_str=!line:Instance ID:=!
	for /f "tokens=* delims= " %%b in ( "!instance_id_str!" ) do set instance_id=%%b

	echo Removing device !instance_id!
	"%WINDIR%\System32\pnputil.exe" /remove-device "!instance_id!"
)

:: Delete old driver if found

set oem_data="%WINDIR%\System32\pnputil.exe /enum-drivers"
set oem_file=

for /F "eol=. tokens=*" %%a in ( '%oem_data%' ) do (

    set line=%%a

    set published_name_str=!line:Published name:=!
    if not !line!==!published_name_str! (
        for /f "tokens=* delims= " %%b in ( "!published_name_str!" ) do set oem_file=%%b
    )

    if not !line!==!line:usbtenki.inf=! (
	echo Found usbtenki driver
	echo Deleting driver !oem_file!
	"%WINDIR%\System32\pnputil.exe" /delete-driver !oem_file! /force  || exit /b 1
    )    
)

setlocal DisableDelayedExpansion

:: Install new driver
"%WINDIR%\System32\pnputil.exe" /add-driver %1 /install || exit /b 2

:: Update system
"%WINDIR%\System32\pnputil.exe" /scan-devices || exit /b 3


exit /b

