@echo off

:: pnputil+devcon based (un)install

:: 1. Remove known/cached devices @USB\VID_289B* or @USB\VID_1781*

:: 2. Search and remove old libusb0 driver package, where:
::   Published name :            oemXYZ.inf
::   Driver package provider :   libusb-win32
::   Signer name :               Dracal...
::
:: 3. Add package %1
::
:: 4. Update system (scan devices)


setlocal EnableDelayedExpansion


if "%~1"=="" (
    echo "No driver package specified"
    echo "Usage: %0 <driver_package_dir_path>"
    exit /b 1
)


echo Installing %1

:: Delete old devices(s)

set devices_data=".\devcon.exe findall @USB\VID_289B* @USB\VID_1781* | findstr USB\"

for /F "eol=. tokens=1*" %%a in ( '%devices_data%' ) do (

	set instance_id=%%a

	echo Removing device !instance_id!
	.\devcon.exe remove "@!instance_id!"
)

:: Delete old driver if found

set oem_data="%WINDIR%\System32\pnputil.exe -e"
set oem_file=

for /F "eol=. tokens=*" %%a in ( '%oem_data%' ) do (

    set line=%%a

    set published_name_str=!line:Published name :=!
    if not !line!==!published_name_str! (
        set package_provider=
        for /f "tokens=* delims= " %%b in ("!published_name_str!") do set oem_file=%%b
    ) else (
    	set dpp_str=!line:Driver package provider :=!
    	if not !line!==!dpp_str! (
            for /f "tokens=* delims= " %%b in ("!dpp_str!") do set package_provider=%%b
    	)
    )

    set signer_name_str=!line:Signer name :=!
    if not !line!==!signer_name_str! (
        if not !signer_name_str!==!signer_name_str:Dracal=! (
            if !package_provider!==libusb-win32 (
                :: TODO: properly check return code
                echo Deleting driver !oem_file!
                "%WINDIR%\System32\pnputil.exe" -f -d !oem_file! || exit /b 1
            )
        )
    )    
)

setlocal DisableDelayedExpansion

:: Install new driver
"%WINDIR%\System32\pnputil.exe" -i -a %1 || exit /b 2

.\devcon.exe rescan || exit /b 3

exit /b 0

